## nvidia-persistenced-470 470.82.00

=== Makefile ===
#
# nvidia-persistenced: A daemon for maintaining persistent driver state,
# specifically for use by the NVIDIA Linux driver.
#
# Copyright (C) 2013 NVIDIA Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
#

##############################################################################
# include common variables and functions
##############################################################################

include utils.mk

##############################################################################
# assign variables
##############################################################################

NVIDIA_PERSISTENCED = $(OUTPUTDIR)/nvidia-persistenced

NVIDIA_PERSISTENCED_PROGRAM_NAME = "nvidia-persistenced"

MANPAGE_GZIP ?= 1

MANPAGE_not_gzipped = $(OUTPUTDIR)/nvidia-persistenced.1
MANPAGE_gzipped     = $(OUTPUTDIR)/nvidia-persistenced.1.gz

ifeq ($(MANPAGE_GZIP),1)
  MANPAGE = $(MANPAGE_gzipped)
else
  MANPAGE = $(MANPAGE_not_gzipped)
endif
GEN_MANPAGE_OPTS = $(OUTPUTDIR_ABSOLUTE)/gen-manpage-opts
OPTIONS_1_INC    = $(OUTPUTDIR)/options.1.inc

##############################################################################
# The calling Makefile may export any of the following variables; we assign
# default values if they are not exported by the caller
##############################################################################

RPC_DIR ?= .
NVIDIA_CFG_DIR ?= .
NVIDIA_NUMA_DIR ?= .
NV_IOCTL_INC_DIR ?= .

##############################################################################
# The common-utils directory may be in one of two places: either elsewhere in
# the driver source tree when building nvidia-persistenced as part of the
# NVIDIA driver build (in which case, COMMON_UTILS_DIR should be defined by
# the calling makefile), or directly in the source directory when building
# from the nvidia-persistenced source tarball (in which case, the below
# conditional assignment should be used)
##############################################################################

COMMON_UTILS_DIR ?= common-utils

# include the list of source files; defines SRC
include dist-files.mk

include $(COMMON_UTILS_DIR)/src.mk
SRC += $(addprefix $(COMMON_UTILS_DIR)/,$(COMMON_UTILS_SRC))

# rpcgen generates code that emits unused variable warnings
$(call BUILD_OBJECT_LIST,$(RPC_SRC)): CFLAGS += -Wno-unused-variable

OBJS = $(call BUILD_OBJECT_LIST,$(SRC))

common_cflags += -I $(COMMON_UTILS_DIR)
common_cflags += -I $(NVIDIA_CFG_DIR)
common_cflags += -I $(NVIDIA_NUMA_DIR)
common_cflags += -I $(NV_IOCTL_INC_DIR)
common_cflags += -I $(RPC_DIR)
common_cflags += -I $(OUTPUTDIR)
common_cflags += -I .

common_cflags += -DPROGRAM_NAME=\"$(NVIDIA_PERSISTENCED_PROGRAM_NAME)\"
common_cflags += -D_BSD_SOURCE
common_cflags += -D_XOPEN_SOURCE=500
common_cflags += -std=c99

CFLAGS += $(common_cflags)
HOST_CFLAGS += $(common_cflags)

ifneq ($(TARGET_OS),FreeBSD)
  LIBS += -ldl
endif

PKG_CONFIG ?= pkg-config

USE_TIRPC ?= $(shell $(PKG_CONFIG) --exists libtirpc && echo 1)

ifeq ($(USE_TIRPC),1)
  TIRPC_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs libtirpc)
  TIRPC_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags libtirpc)
  $(call BUILD_OBJECT_LIST,$(SRC)): CFLAGS += $(TIRPC_CFLAGS)
  LIBS += $(TIRPC_LDFLAGS)
endif

##############################################################################
# build rules
##############################################################################
.PHONY: all install NVIDIA_PERSISTENCED_install MANPAGE_install clean clobber

all: $(NVIDIA_PERSISTENCED) $(MANPAGE)

install: NVIDIA_PERSISTENCED_install MANPAGE_install

NVIDIA_PERSISTENCED_install: $(NVIDIA_PERSISTENCED)
	$(MKDIR) $(BINDIR)
	$(INSTALL) $(INSTALL_BIN_ARGS) $< $(BINDIR)/$(notdir $<)

MANPAGE_install: $(MANPAGE)
	$(MKDIR) $(MANDIR)
	$(INSTALL) $(INSTALL_BIN_ARGS) $< $(MANDIR)/$(notdir $<)

$(eval $(call DEBUG_INFO_RULES, $(NVIDIA_PERSISTENCED)))
$(NVIDIA_PERSISTENCED).unstripped: $(OBJS)
	$(call quiet_cmd,LINK) $(CFLAGS) $(LDFLAGS) $(BIN_LDFLAGS) \
		-o $@ $(OBJS) $(LIBS)

# define the rule to build each object file
$(foreach src, $(SRC), $(eval $(call DEFINE_OBJECT_RULE,TARGET,$(src))))

clean clobber:
	$(RM) -rf $(NVIDIA_PERSISTENCED) $(MANPAGE) *~ \
		$(OUTPUTDIR)/*.o $(OUTPUTDIR)/*.d \
		$(GEN_MANPAGE_OPTS) $(OPTIONS_1_INC)

##############################################################################
# documentation
##############################################################################

AUTO_TEXT = ".\\\" WARNING: THIS FILE IS AUTO_GENERATED!  Edit $< instead."

doc: $(MANPAGE)

GEN_MANPAGE_OPTS_SRC = gen-manpage-opts.c
GEN_MANPAGE_OPTS_SRC += $(COMMON_UTILS_DIR)/gen-manpage-opts-helper.c

GEN_MANPAGE_OPTS_OBJS = $(call BUILD_OBJECT_LIST,$(GEN_MANPAGE_OPTS_SRC))

$(foreach src,$(GEN_MANPAGE_OPTS_SRC), \
    $(eval $(call DEFINE_OBJECT_RULE,HOST,$(src))))

$(GEN_MANPAGE_OPTS): $(GEN_MANPAGE_OPTS_OBJS)
	$(call quiet_cmd,HOST_LINK) \
		$(HOST_CFLAGS) $(HOST_LDFLAGS) $(HOST_BIN_LDFLAGS) $^ -o $@

$(OPTIONS_1_INC): $(GEN_MANPAGE_OPTS)
	@$< > $@

$(MANPAGE_not_gzipped): nvidia-persistenced.1.m4 $(OPTIONS_1_INC) $(VERSION_MK)
	$(call quiet_cmd,M4) -D__HEADER__=$(AUTO_TEXT) -I $(OUTPUTDIR) \
	  -D__VERSION__=$(NVIDIA_VERSION) \
	  -D__DATE__="`$(DATE) +%F`" \
	  -D__BUILD_OS__=$(TARGET_OS) \
	  $< > $@

$(MANPAGE_gzipped): $(MANPAGE_not_gzipped)
	$(GZIP_CMD) -9nf < $< > $@

=== debian/changelog ===
nvidia-persistenced-470 (470.82.00-2) UNRELEASED; urgency=medium

  * Rename package.

 -- huxiaodong <huxiaodong@uniontech.com>  Mon, 30 May 2022 14:27:06 +0800

nvidia-persistenced-470 (470.82.00-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 08 Nov 2021 11:27:53 +0100

nvidia-persistenced-470 (470.57.02-1) unstable; urgency=medium

  * New upstream release.
  * Add libnvidia-tesla-{470,460}-cfg1 as alternative dependencies.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 02 Aug 2021 13:06:55 +0200

nvidia-persistenced-470 (460.32.03-1) unstable; urgency=medium

  * New upstream release.
  * Restore hardening flags.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 15 Jan 2021 14:28:03 +0100

nvidia-persistenced-470 (455.45.01-1) unstable; urgency=medium

  * New upstream release.
  * Bump watch version to 4. No changes needed.
  * Bump Standards-Version to 4.5.1. No changes needed.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 06 Jan 2021 16:37:12 +0100

nvidia-persistenced-470 (450.57-1) unstable; urgency=medium

  * New upstream release.
  * Build against libtirpc-dev.
  * Switch to debhelper-compat (= 13).
  * Build for arm64.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 23 Jul 2020 17:06:40 +0200

nvidia-persistenced-470 (440.44-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 30 Jan 2020 00:37:19 +0100

nvidia-persistenced-470 (435.21-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 22 Jan 2020 20:18:24 +0100

nvidia-persistenced-470 (430.64-1) unstable; urgency=medium

  * New upstream release.
  * Build for ppc64el.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 14 Nov 2019 22:35:11 +0100

nvidia-persistenced-470 (430.50-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.4.1. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 15 Oct 2019 13:46:53 +0200

nvidia-persistenced-470 (418.56-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 22 Apr 2019 16:15:55 +0200

nvidia-persistenced-470 (415.27-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Apr 2019 05:44:34 +0200

nvidia-persistenced-470 (410.104-1) unstable; urgency=medium

  * New upstream release.
  * Adjust libnvidia-cfg1 dependencies to automatically switch to the legacy
    package on upgrades from stretch to buster on [!amd64].

 -- Andreas Beckmann <anbe@debian.org>  Mon, 25 Mar 2019 18:07:00 +0100

nvidia-persistenced-470 (410.93-1) unstable; urgency=medium

  * New upstream release.
  * Upstream now builds reproducibly.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Feb 2019 18:23:51 +0100

nvidia-persistenced-470 (396.54-1) unstable; urgency=medium

  * New upstream release.
  * Switch to debhelper-compat (= 12).
  * Drop Breaks+Replaces against packages predating jessie.
  * Start nvidia-persistenced-470 as a regular service, thanks to Cédric Dufour.
    (Closes: #915381)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 09 Feb 2019 15:01:38 +0100

nvidia-persistenced-470 (390.87-1~deb9u1) stretch; urgency=medium

  * Rebuild for stretch.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 Feb 2019 23:11:08 +0100

nvidia-persistenced-470 (390.87-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.3.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 17 Jan 2019 22:45:48 +0100

nvidia-persistenced-470 (390.25-1) unstable; urgency=medium

  * New upstream release.
  * Add debian/upstream/metadata.
  * Fix new Lintian issues.
  * Switch Vcs-* URLs to salsa.debian.org.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 06 Mar 2018 04:13:59 +0100

nvidia-persistenced-470 (384.111-1~deb9u1) stretch; urgency=medium

  * Rebuild for stretch.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 26 Feb 2018 00:36:01 +0100

nvidia-persistenced-470 (384.111-1) unstable; urgency=medium

  * New upstream release.
  * B-D: dpkg-dev (>= 1.18.8) for SOURCE_DATE_EPOCH in pkg-info.mk.
  * Bump Standards-Version to 4.1.3. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 13 Jan 2018 18:40:41 +0100

nvidia-persistenced-470 (384.98-1) unstable; urgency=medium

  * New upstream release.
    - Updated nvidia-persistenced-470 to initialize nvidia-modeset.ko in
      addition to nvidia.ko when setting persistence mode.
  * Use https:// URL in the watch file.
  * Bump Standards-Version to 4.1.1. No changes needed.
  * Set Rules-Requires-Root: no.
  * Use dpkg makefile snippets instead of manual changelog parsing.
  * Use a fixed OUTPUTDIR for improved reproducibility.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 17 Nov 2017 02:50:48 +0100

nvidia-persistenced-470 (375.26-2) unstable; urgency=medium

  * Add Depends: libnvidia-cfg1 | libnvidia-cfg1-any, thanks to Gero Müller.
  * Do not build for ppc64el which does not have a curent driver packaged.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 18 Jan 2017 16:16:20 +0100

nvidia-persistenced-470 (375.26-1) unstable; urgency=medium

  * New upstream release.
  * Switch to debhelper compat level 10.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 13 Jan 2017 03:21:35 +0100

nvidia-persistenced-470 (367.57-1) unstable; urgency=medium

  * New upstream release.
    - Fixed a bug in nvidia-persistenced-470 that caused it to incorrectly delete
      the PID file if a second instance of the daemon is started.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 15 Oct 2016 16:28:30 +0200

nvidia-persistenced-470 (367.44-1) unstable; urgency=medium

  * New upstream release.
    - Changed the behavior of nvidia-persistenced-470 to enable persistence mode


=== debian/control ===
Source: nvidia-persistenced-470
Section: contrib/utils
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 12),
 pkg-config,
 libtirpc-dev,
 m4,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/NVIDIA/nvidia-persistenced-470
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-persistenced-470
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-persistenced-470.git

Package: nvidia-persistenced-470
Architecture: i386 amd64 armhf arm64 ppc64el
Multi-Arch: foreign
Conflicts:
 nvidia-persistenced,
 nvidia-persistenced-390,
 nvidia-persistenced-460,
Replaces:
 nvidia-persistenced,
 nvidia-persistenced-390,
 nvidia-persistenced-460,
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libnvidia-cfg1 [!i386 !armhf !ppc64el]
 | libnvidia-tesla-470-cfg1 [amd64 arm64 ppc64el]
 | libnvidia-tesla-460-cfg1 [amd64 arm64 ppc64el]
 | libnvidia-tesla-450-cfg1 [amd64 arm64 ppc64el]
 | libnvidia-tesla-418-cfg1 [amd64 ppc64el]
 | libnvidia-legacy-390xx-cfg1 [amd64 i386 armhf]
 | libnvidia-legacy-340xx-cfg1 [amd64 i386 armhf]
 | libnvidia-cfg.so.1
 | libnvidia-cfg1-any,
 adduser,
 ${shlibs:Depends},
 ${misc:Depends}
Description: daemon to maintain persistent software state in the NVIDIA driver
 When persistence mode is enabled, the daemon prevents the driver from
 releasing device state when the device is not in use.
 This can improve the startup time of new clients in this scenario.
